import * as TS from 'typescript/lib/tsserverlibrary';

interface Modules {
  typescript: typeof TS
}

interface PluginConfig {
  telemetry?: boolean
  features: {
    diagnostics: boolean | Array<'semantic' | 'syntactic' | 'suggestion'>
    organizeImports: boolean
    quickInfo: boolean
    rename: boolean
    refactor: boolean
    goto: boolean
    tagCompletions: boolean | Array<'html' | 'svg'>
  }
  /** A file to communicate with extension? */
  extensionSocketFileName?: string
}

declare type PluginCreateInfo = Omit<TS.server.PluginCreateInfo, 'config'> & {
    config: PluginConfig;
};
declare function init({ typescript }: Modules): TS.server.PluginModule;

export default init;
export { PluginConfig, PluginCreateInfo };
